import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Stack;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.dom4j.io.XMLWriter;

import com.justep.ui.WindowExtendsEngine;
import com.justep.ui.resources.ResourceManagerWrapper;
import com.justep.ui.xml.XMLUtils;
import com.justep.xbl.dom.DefaultXMLDocument;
import com.justep.xbl.io.XMLContentHandler;

public class WindowExtends extends com.justep.ui.impl.JProcessorImpl {

	@Override
	public void execute(HttpServletRequest request, HttpServletResponse response)
			throws ServletException, IOException {
		String oldPath = request.getParameter("old");
		String realOldPath = ResourceManagerWrapper.instance().getRealPath(oldPath);
		
		DefaultXMLDocument window;
		FileInputStream inputStream = new FileInputStream(new File(realOldPath));
		try {
			XMLContentHandler contentHandler = new XMLContentHandler();
			XMLUtils.inputStreamToSAX(inputStream, realOldPath, contentHandler, false, false);
			window = contentHandler.getDocument();
		} finally {
			inputStream.close();
		}
		
		
		window.setDocumentURL(oldPath);
		WindowExtendsEngine.execute(window, new Stack<String>());

		if (window.getRootElement().attribute("extends") != null)
			window.getRootElement().attribute("extends").detach();
		
		
		String newPath = request.getParameter("new");
		String realNewPath = ResourceManagerWrapper.instance().getRealPath(newPath);
		XMLWriter writer = new XMLWriter(new FileOutputStream(realNewPath));
		writer.write(window);
		writer.close();
	}

}
